---------------------------------------------------------------------------
-- This VHDL file was developed by Daniel Llamocca (2013).  It may be
-- freely copied and/or distributed at no cost.  Any persons using this
-- file for any purpose do so at their own risk, and are responsible for
-- the results of such use.  Daniel Llamocca does not guarantee that
-- this file is complete, correct, or fit for any particular purpose.
-- NO WARRANTY OF ANY KIND IS EXPRESSED OR IMPLIED.  This notice must
-- accompany any copy of this file.
--------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity my_alu_logic is
   generic (N: INTEGER:= 8);
	port ( A, B: in std_logic_vector (N-1 downto 0);
			  sel: in std_logic_vector (2 downto 0);
	          y: out std_logic_vector (N-1 downto 0));
end my_alu_logic;

architecture structure of my_alu_logic is

begin

	with sel select
			y <= not (A)   when "000",
			     not (B)   when "001",
				  A and B   when "010",
				  A or  B   when "011",
				  A nand B  when "100",
				  A nor B   when "101",
				  A xor B   when "110",
				  A xnor B  when "111",
				  (others => '0') when others;

end structure;

